Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/CorpusPage.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/CorpusPage.java	(revision 2441)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/CorpusPage.java	(revision 2442)
@@ -169,588 +193,560 @@
 		TableWrapLayout layout = new TableWrapLayout();
 		layout.numColumns = 2;
 		layout.makeColumnsEqualWidth = false;
-
+		
 		form.getBody().setLayout(layout);
-
+		
 		createToolbar();
-
+		
 		String importName = editor.getGroovyscript().getName();
 		moduleParams = ImportModuleCustomization.getParameters(importName);
-
+		
 		// CREATE THE SECTIONS
 		int N_SECTIONS = 0;
 		N_SECTIONS += createInfosSection(); // mandatory
-
+		
 		if (moduleParams.get(ImportModuleCustomization.ENCODING)) {
 			N_SECTIONS += createEncodingSection();
 		}
-
+		
 		if (moduleParams.get(ImportModuleCustomization.LANG)) {
 			N_SECTIONS += createLangSection();
 		}
-
+		
 		if (moduleParams.get(ImportModuleCustomization.TOKENIZER)) {
 			N_SECTIONS += createTokenizerSection();
 		}
-
+		
 		if (moduleParams.get(ImportModuleCustomization.XSLT)) {
-			if (N_SECTIONS%2 != 0) { // needs 2 cells to draw
+			if (N_SECTIONS % 2 != 0) { // needs 2 cells to draw
 				N_SECTIONS += createEmptyCell();
 			}
 			N_SECTIONS += createFrontXSLTSection();
 		}
-
-		if (moduleParams.get(ImportModuleCustomization.EDITIONS_PAGEELEMENT) || moduleParams.get(ImportModuleCustomization.EDITIONS_WORDSPERPAGE) ) {
+		
+		if (moduleParams.get(ImportModuleCustomization.EDITIONS_PAGEELEMENT) || moduleParams.get(ImportModuleCustomization.EDITIONS_WORDSPERPAGE)) {
 			N_SECTIONS += createEditionsSection();
 		}
-
+		
 		N_SECTIONS += createFontSection();
-
+		
 		if (moduleParams.get(ImportModuleCustomization.UI)) {
 			N_SECTIONS += createUIsSection();
 		}
-
+		
 		if (moduleParams.get(ImportModuleCustomization.TEXTUALPLANS)) {
 			N_SECTIONS += createTextualPlansSection();
 		}
 		if (moduleParams.get(ImportModuleCustomization.OPTIONS)) {
 			N_SECTIONS += createOptionsSection();
 		}
-
+		
 		// END OF SECTIONS CREATION, ENSURE THAT THE NUMBER OF CELL is %2
-		if (N_SECTIONS%2 != 0) N_SECTIONS += createEmptyCell();
-
+		if (N_SECTIONS % 2 != 0) N_SECTIONS += createEmptyCell();
+		
 		// create notes messages
-		Label separatorLabel = toolkit.createLabel(form.getBody(), "",SWT.SEPARATOR | SWT.HORIZONTAL); //$NON-NLS-1$
-		TableWrapData gdata = new TableWrapData(TableWrapData.FILL_GRAB, TableWrapData.MIDDLE, 2,1);
+		Label separatorLabel = toolkit.createLabel(form.getBody(), "", SWT.SEPARATOR | SWT.HORIZONTAL); //$NON-NLS-1$
+		TableWrapData gdata = new TableWrapData(TableWrapData.FILL_GRAB, TableWrapData.MIDDLE, 2, 1);
 		gdata.colspan = 2;
 		separatorLabel.setLayoutData(gdata);
-
+		
 		Label mandatoryLabel = toolkit.createLabel(form.getBody(), TXMUIMessages.dDotMandatoryField, SWT.WRAP);
-		gdata = new TableWrapData(TableWrapData.FILL, TableWrapData.MIDDLE, 2,1);
+		gdata = new TableWrapData(TableWrapData.FILL, TableWrapData.MIDDLE, 2, 1);
 		gdata.colspan = 2;
 		mandatoryLabel.setLayoutData(gdata);
-
+		
 		form.layout(true);
 		managedForm.reflow(true);
 	}
-
+	
 	private int createTextualPlansSection() {
-		textualPlansSection = new TextualPlansSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		textualPlansSection = new TextualPlansSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE);
 		return textualPlansSection.getSectionSize();
 	}
-
+	
 	private int createOptionsSection() {
-		optionsSection = new OptionsSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		optionsSection = new OptionsSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE);
 		return optionsSection.getSectionSize();
 	}
-
+	
 	private int createInfosSection() {
-		infosSection = new InfosSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		infosSection = new InfosSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE);
 		return infosSection.getSectionSize();
 	}
-
+	
 	/**
 	 * Creates the front xslt section.
 	 */
 	private int createFrontXSLTSection() {
-		xsltSection = new FrontXSLSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		xsltSection = new FrontXSLSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE);
 		return xsltSection.getSectionSize();
 	}
-
+	
 	/**
 	 * Creates the lang section.
 	 */
 	private int createLangSection() {
-		langSection = new LangSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		langSection = new LangSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE);
 		return langSection.getSectionSize();
 	}
-
+	
 	private void createPAttributesSection() {
-		/*	pattrSection = toolkit.createSection(form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
-		pattrSection.setText(Messages.CorpusPage_10);
-		GridLayout layout = new GridLayout(1, true);
-		pattrSection.setLayout(layout);
-		pattrSection.setLayoutData(getSectionGridData(2));
-		pattrSection.setEnabled(false);
-
-		pattrSection.addExpansionListener(new ExpansionAdapter() {
-			@Override
-			public void expansionStateChanged(ExpansionEvent e) {form.layout(true);}
-		});
-
-		Composite sectionClient = toolkit.createComposite(pattrSection);
-		sectionClient.setLayout(new GridLayout(2, false));
-		pattrSection.setClient(sectionClient);
-
-		Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_11, SWT.PUSH);
-		addButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		addButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
-				values.put("id", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("shortname", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("longname", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("pattern", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("renderer", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("tooltip", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("type", "String"); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("import", "true"); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("mandatory", "true"); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("inputFormat", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("outputFormat", ""); //$NON-NLS-1$ //$NON-NLS-2$
-
-				MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_12, values);
-				if (dlg.open() == Window.OK) {
-					params.addPAttribute(params.getCorpusElement(), values.get("id"), values.get("shortname"), values.get("longname"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-							values.get("type"), values.get("renderer"), values.get("tooltip"),  //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-							values.get("pattern"), values.get("import"), values.get("mandatory"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-							values.get("inputFormat"), values.get("outputFormat")); //$NON-NLS-1$ //$NON-NLS-2$
-					updatePAttributeSection();
-				}
-			}
-		});
-
-		Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_13, SWT.PUSH);
-		removeButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		removeButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				ISelection sel = pattributesViewer.getSelection();
-				IStructuredSelection ssel = (IStructuredSelection) sel;
-				Object obj = ssel.getFirstElement();
-				if (obj instanceof Element) {
-					Element query = (Element) obj;
-					params.getPAttributesElement(params.getCorpusElement()).removeChild(query);
-					updatePAttributeSection();
-				}
-			}
-		});
-
-		Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
-		pattributesViewer = new TableViewer(table);
-		pattributesViewer.getTable().addKeyListener(new TableKeyListener(pattributesViewer));
-		GridData gd = new GridData(GridData.FILL, GridData.FILL, false, false,2,1);
-		gd.heightHint = 150;
-		pattributesViewer.getTable().setLayoutData(gd);
-		pattributesViewer.setContentProvider(new NodeListContentProvider());
-		pattributesViewer.getTable().setHeaderVisible(true);
-		pattributesViewer.getTable().setLinesVisible(true);
-
-		String[] cols = {"id", "shortname", "longname", "import", "mandatory", "pattern", "renderer", "tooltip", "type"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$
-		for (String col : cols) {
-			TableViewerColumn columnViewer = new TableViewerColumn(pattributesViewer, SWT.NONE);
-			TableColumn column = columnViewer.getColumn();
-			column.setText(col);
-			column.setWidth(100);
-			columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
-		}
+		/*
+		 * pattrSection = toolkit.createSection(form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		 * pattrSection.setText(Messages.CorpusPage_10);
+		 * GridLayout layout = new GridLayout(1, true);
+		 * pattrSection.setLayout(layout);
+		 * pattrSection.setLayoutData(getSectionGridData(2));
+		 * pattrSection.setEnabled(false);
+		 * pattrSection.addExpansionListener(new ExpansionAdapter() {
+		 * @Override
+		 * public void expansionStateChanged(ExpansionEvent e) {form.layout(true);}
+		 * });
+		 * Composite sectionClient = toolkit.createComposite(pattrSection);
+		 * sectionClient.setLayout(new GridLayout(2, false));
+		 * pattrSection.setClient(sectionClient);
+		 * Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_11, SWT.PUSH);
+		 * addButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		 * addButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
+		 * values.put("id", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("shortname", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("longname", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("pattern", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("renderer", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("tooltip", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("type", "String"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("import", "true"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("mandatory", "true"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("inputFormat", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("outputFormat", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_12, values);
+		 * if (dlg.open() == Window.OK) {
+		 * params.addPAttribute(params.getCorpusElement(), values.get("id"), values.get("shortname"), values.get("longname"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * values.get("type"), values.get("renderer"), values.get("tooltip"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * values.get("pattern"), values.get("import"), values.get("mandatory"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * values.get("inputFormat"), values.get("outputFormat")); //$NON-NLS-1$ //$NON-NLS-2$
+		 * updatePAttributeSection();
+		 * }
+		 * }
+		 * });
+		 * Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_13, SWT.PUSH);
+		 * removeButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		 * removeButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * ISelection sel = pattributesViewer.getSelection();
+		 * IStructuredSelection ssel = (IStructuredSelection) sel;
+		 * Object obj = ssel.getFirstElement();
+		 * if (obj instanceof Element) {
+		 * Element query = (Element) obj;
+		 * params.getPAttributesElement(params.getCorpusElement()).removeChild(query);
+		 * updatePAttributeSection();
+		 * }
+		 * }
+		 * });
+		 * Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
+		 * pattributesViewer = new TableViewer(table);
+		 * pattributesViewer.getTable().addKeyListener(new TableKeyListener(pattributesViewer));
+		 * GridData gd = new GridData(GridData.FILL, GridData.FILL, false, false,2,1);
+		 * gd.heightHint = 150;
+		 * pattributesViewer.getTable().setLayoutData(gd);
+		 * pattributesViewer.setContentProvider(new NodeListContentProvider());
+		 * pattributesViewer.getTable().setHeaderVisible(true);
+		 * pattributesViewer.getTable().setLinesVisible(true);
+		 * String[] cols = {"id", "shortname", "longname", "import", "mandatory", "pattern", "renderer", "tooltip", "type"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+		 * //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$
+		 * for (String col : cols) {
+		 * TableViewerColumn columnViewer = new TableViewerColumn(pattributesViewer, SWT.NONE);
+		 * TableColumn column = columnViewer.getColumn();
+		 * column.setText(col);
+		 * column.setWidth(100);
+		 * columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
+		 * }
 		 */
 	}
-
+	
 	private void createPreBuildSection() {
-		/*	preBuildSection = toolkit.createSection(form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
-		preBuildSection.setText(Messages.CorpusPage_14);
-		GridLayout layout = new GridLayout(1, true);
-		preBuildSection.setLayout(layout);
-		preBuildSection.setLayoutData(getSectionGridData(2));
-		preBuildSection.setEnabled(false);
-
-		preBuildSection.addExpansionListener(new ExpansionAdapter() {
-			@Override
-			public void expansionStateChanged(ExpansionEvent e) {form.layout(true);}
-		});
-
-		Composite sectionClient = toolkit.createComposite(preBuildSection);
-		sectionClient.setLayout(new GridLayout(4, false));
-		preBuildSection.setClient(sectionClient);
-
-		Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_15, SWT.PUSH);
-		addButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		addButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
-				values.put("subcorpus", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("query", "[]"); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("desc", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_15, values);
-				if (dlg.open() == Window.OK) {
-					params.addSubcorpus(params.getCorpusElement(), values.get("subcorpus"), values.get("query"), values.get("desc")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-					updatePreBuildSection();
-				}
-			}
-		});
-
-		Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_17, SWT.PUSH);
-		removeButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		removeButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				ISelection sel = preBuildViewer.getSelection();
-				IStructuredSelection ssel = (IStructuredSelection) sel;
-				Object obj = ssel.getFirstElement();
-				if (obj instanceof Element) {
-					Element subcorpus = (Element) obj;
-					System.out.println("SELECTED: "+subcorpus); //$NON-NLS-1$
-					params.getPreBuildElement(params.getCorpusElement()).removeChild(subcorpus);
-					updatePreBuildSection();
-				}
-			}
-		});
-
-		Button add2Button = toolkit.createButton(sectionClient, Messages.CorpusPage_18, SWT.PUSH);
-		add2Button.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		add2Button.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
-				values.put("partition", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				ArrayList<LinkedHashMap<String, String>> subvaluesArray = new ArrayList<LinkedHashMap<String, String>>();
-				LinkedHashMap<String, String> subvalues = new LinkedHashMap<String, String>();
-				subvaluesArray.add(subvalues);
-				subvalues.put("part", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				subvalues.put("query", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				MultipleValueTreeDialog dlg = new MultipleValueTreeDialog(form.getShell(), Messages.CorpusPage_18, values, subvaluesArray, "part"); //$NON-NLS-1$
-				if (dlg.open() == Window.OK) {
-					String[] names = new String[subvaluesArray.size()];
-					String[] queries = new String[subvaluesArray.size()];
-					for (int i = 0 ; i < subvaluesArray.size() ; i++) {
-						LinkedHashMap<String, String> it = subvaluesArray.get(i);
-						names[i] = it.get("part"); //$NON-NLS-1$
-						queries[i] = it.get("query"); //$NON-NLS-1$
-					}
-					params.addPartition(params.getCorpusElement(), values.get("partition"), queries, names); //$NON-NLS-1$
-					updatePreBuildSection();
-				}
-			}
-		});
-
-		Button remove2Button = toolkit.createButton(sectionClient, Messages.CorpusPage_20, SWT.PUSH);
-		remove2Button.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		remove2Button.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				ISelection sel = preBuildViewer2.getSelection();
-				IStructuredSelection ssel = (IStructuredSelection) sel;
-				Object obj = ssel.getFirstElement();
-				System.out.println("SELECTED: "+obj); //$NON-NLS-1$
-				if (obj instanceof Element) {
-					Element partitionElem = (Element) obj;
-					if (partitionElem.getParentNode().equals(params.getPreBuildElement(params.getCorpusElement())))
-					{	params.getPreBuildElement(params.getCorpusElement()).removeChild(partitionElem);
-					updatePreBuildSection();
-					}
-				}
-			}
-		});
-
-		Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
-		preBuildViewer = new TableViewer(table);
-		preBuildViewer.getTable().addKeyListener(new TableKeyListener(preBuildViewer));
-		GridData gd = new GridData(GridData.FILL, GridData.FILL, false, false,1,1);
-		gd.heightHint = 150;
-		preBuildViewer.getTable().setLayoutData(gd);
-		preBuildViewer.setContentProvider(new NodeListContentProvider());
-		preBuildViewer.getTable().setHeaderVisible(true);
-		preBuildViewer.getTable().setLinesVisible(true);
-
-		String[] cols = {"name", "query", "desc"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-		for (String col : cols) {
-			TableViewerColumn columnViewer = new TableViewerColumn(preBuildViewer, SWT.NONE);
-			TableColumn column = columnViewer.getColumn();
-			column.setText(col);
-			column.setWidth(100);
-			columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
-		}
-
-		Tree table2 = toolkit.createTree(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
-		preBuildViewer2 = new TreeViewer(table2);
-		GridData gd2 = new GridData(GridData.FILL, GridData.FILL, false, false, 3, 1);
-		gd2.heightHint = 150;
-		preBuildViewer2.getTree().setLayoutData(gd2);
-		preBuildViewer2.getTree().setHeaderVisible(true);
-		preBuildViewer2.getTree().setLinesVisible(true);
-
-		String[] cols1 = {"name"}; //$NON-NLS-1$
-		String[] cols2 = {"name", "query"}; //$NON-NLS-1$ //$NON-NLS-2$
-		preBuildViewer2.setContentProvider(new ElementTreeContentProvider("partition", "part", cols1, cols2)); //$NON-NLS-1$ //$NON-NLS-2$
-		//preBuildViewer2.setLabelProvider(new ElementTreeLabelProvider("partition", "part", cols1, cols2));
-
-		int c = 0;
-		for (String col : cols2) {
-			TreeViewerColumn columnViewer = new TreeViewerColumn(preBuildViewer2, SWT.NONE);
-			TreeColumn column = columnViewer.getColumn();
-			column.setText(col);
-			column.setWidth(100);
-			columnViewer.setLabelProvider(new ElementTreeLabelProvider(c++, "partition", "part", cols1, cols2)); //$NON-NLS-1$ //$NON-NLS-2$
-		}
+		/*
+		 * preBuildSection = toolkit.createSection(form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		 * preBuildSection.setText(Messages.CorpusPage_14);
+		 * GridLayout layout = new GridLayout(1, true);
+		 * preBuildSection.setLayout(layout);
+		 * preBuildSection.setLayoutData(getSectionGridData(2));
+		 * preBuildSection.setEnabled(false);
+		 * preBuildSection.addExpansionListener(new ExpansionAdapter() {
+		 * @Override
+		 * public void expansionStateChanged(ExpansionEvent e) {form.layout(true);}
+		 * });
+		 * Composite sectionClient = toolkit.createComposite(preBuildSection);
+		 * sectionClient.setLayout(new GridLayout(4, false));
+		 * preBuildSection.setClient(sectionClient);
+		 * Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_15, SWT.PUSH);
+		 * addButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		 * addButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
+		 * values.put("subcorpus", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("query", "[]"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("desc", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_15, values);
+		 * if (dlg.open() == Window.OK) {
+		 * params.addSubcorpus(params.getCorpusElement(), values.get("subcorpus"), values.get("query"), values.get("desc")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * updatePreBuildSection();
+		 * }
+		 * }
+		 * });
+		 * Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_17, SWT.PUSH);
+		 * removeButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		 * removeButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * ISelection sel = preBuildViewer.getSelection();
+		 * IStructuredSelection ssel = (IStructuredSelection) sel;
+		 * Object obj = ssel.getFirstElement();
+		 * if (obj instanceof Element) {
+		 * Element subcorpus = (Element) obj;
+		 * System.out.println("SELECTED: "+subcorpus); //$NON-NLS-1$
+		 * params.getPreBuildElement(params.getCorpusElement()).removeChild(subcorpus);
+		 * updatePreBuildSection();
+		 * }
+		 * }
+		 * });
+		 * Button add2Button = toolkit.createButton(sectionClient, Messages.CorpusPage_18, SWT.PUSH);
+		 * add2Button.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		 * add2Button.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
+		 * values.put("partition", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * ArrayList<LinkedHashMap<String, String>> subvaluesArray = new ArrayList<LinkedHashMap<String, String>>();
+		 * LinkedHashMap<String, String> subvalues = new LinkedHashMap<String, String>();
+		 * subvaluesArray.add(subvalues);
+		 * subvalues.put("part", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * subvalues.put("query", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * MultipleValueTreeDialog dlg = new MultipleValueTreeDialog(form.getShell(), Messages.CorpusPage_18, values, subvaluesArray, "part"); //$NON-NLS-1$
+		 * if (dlg.open() == Window.OK) {
+		 * String[] names = new String[subvaluesArray.size()];
+		 * String[] queries = new String[subvaluesArray.size()];
+		 * for (int i = 0 ; i < subvaluesArray.size() ; i++) {
+		 * LinkedHashMap<String, String> it = subvaluesArray.get(i);
+		 * names[i] = it.get("part"); //$NON-NLS-1$
+		 * queries[i] = it.get("query"); //$NON-NLS-1$
+		 * }
+		 * params.addPartition(params.getCorpusElement(), values.get("partition"), queries, names); //$NON-NLS-1$
+		 * updatePreBuildSection();
+		 * }
+		 * }
+		 * });
+		 * Button remove2Button = toolkit.createButton(sectionClient, Messages.CorpusPage_20, SWT.PUSH);
+		 * remove2Button.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		 * remove2Button.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * ISelection sel = preBuildViewer2.getSelection();
+		 * IStructuredSelection ssel = (IStructuredSelection) sel;
+		 * Object obj = ssel.getFirstElement();
+		 * System.out.println("SELECTED: "+obj); //$NON-NLS-1$
+		 * if (obj instanceof Element) {
+		 * Element partitionElem = (Element) obj;
+		 * if (partitionElem.getParentNode().equals(params.getPreBuildElement(params.getCorpusElement())))
+		 * { params.getPreBuildElement(params.getCorpusElement()).removeChild(partitionElem);
+		 * updatePreBuildSection();
+		 * }
+		 * }
+		 * }
+		 * });
+		 * Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
+		 * preBuildViewer = new TableViewer(table);
+		 * preBuildViewer.getTable().addKeyListener(new TableKeyListener(preBuildViewer));
+		 * GridData gd = new GridData(GridData.FILL, GridData.FILL, false, false,1,1);
+		 * gd.heightHint = 150;
+		 * preBuildViewer.getTable().setLayoutData(gd);
+		 * preBuildViewer.setContentProvider(new NodeListContentProvider());
+		 * preBuildViewer.getTable().setHeaderVisible(true);
+		 * preBuildViewer.getTable().setLinesVisible(true);
+		 * String[] cols = {"name", "query", "desc"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * for (String col : cols) {
+		 * TableViewerColumn columnViewer = new TableViewerColumn(preBuildViewer, SWT.NONE);
+		 * TableColumn column = columnViewer.getColumn();
+		 * column.setText(col);
+		 * column.setWidth(100);
+		 * columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
+		 * }
+		 * Tree table2 = toolkit.createTree(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
+		 * preBuildViewer2 = new TreeViewer(table2);
+		 * GridData gd2 = new GridData(GridData.FILL, GridData.FILL, false, false, 3, 1);
+		 * gd2.heightHint = 150;
+		 * preBuildViewer2.getTree().setLayoutData(gd2);
+		 * preBuildViewer2.getTree().setHeaderVisible(true);
+		 * preBuildViewer2.getTree().setLinesVisible(true);
+		 * String[] cols1 = {"name"}; //$NON-NLS-1$
+		 * String[] cols2 = {"name", "query"}; //$NON-NLS-1$ //$NON-NLS-2$
+		 * preBuildViewer2.setContentProvider(new ElementTreeContentProvider("partition", "part", cols1, cols2)); //$NON-NLS-1$ //$NON-NLS-2$
+		 * //preBuildViewer2.setLabelProvider(new ElementTreeLabelProvider("partition", "part", cols1, cols2));
+		 * int c = 0;
+		 * for (String col : cols2) {
+		 * TreeViewerColumn columnViewer = new TreeViewerColumn(preBuildViewer2, SWT.NONE);
+		 * TreeColumn column = columnViewer.getColumn();
+		 * column.setText(col);
+		 * column.setWidth(100);
+		 * columnViewer.setLabelProvider(new ElementTreeLabelProvider(c++, "partition", "part", cols1, cols2)); //$NON-NLS-1$ //$NON-NLS-2$
+		 * }
 		 */
 	}
+	
 	private void createQueriesSection() {
-		/*	querySection = toolkit.createSection(form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
-		querySection.setText("Queries"); //$NON-NLS-1$
-		GridLayout layout = new GridLayout(1, true);
-		querySection.setLayout(layout);
-		querySection.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false, 2, 1));
-		querySection.setEnabled(false);
-
-		querySection.addExpansionListener(new ExpansionAdapter() {
-			@Override
-			public void expansionStateChanged(ExpansionEvent e) {form.layout(true);}
-		});
-
-		//filesection.setDescription("Select how to find source files");
-		Composite sectionClient = toolkit.createComposite(querySection);
-		sectionClient.setLayout(new GridLayout(2, false));
-		querySection.setClient(sectionClient);
-
-		Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_21, SWT.PUSH);
-		addButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		addButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {				
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
-				values.put("name", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("query", "[]"); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("desc", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_21, values);
-				if (dlg.open() == Window.OK) {
-					params.addQuery(params.getCorpusElement(), values.get("name"), values.get("query"), values.get("desc")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-					updateQuerySection();
-				}
-			}
-		});
-
-		Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_23, SWT.PUSH);
-		removeButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		removeButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				ISelection sel = queriesViewer.getSelection();
-				IStructuredSelection ssel = (IStructuredSelection) sel;
-				Object obj = ssel.getFirstElement();
-				if (obj instanceof Element) {
-					Element query = (Element) obj;
-					params.getQueriesElement(params.getCorpusElement()).removeChild(query);
-					updateQuerySection();
-				}
-			}
-		});
-
-		Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
-		queriesViewer = new TableViewer(table);
-		queriesViewer.getTable().addKeyListener(new TableKeyListener(queriesViewer));
-		GridData gd = new GridData(GridData.FILL, GridData.FILL, false, false,2,1);
-		gd.heightHint = 150;
-		queriesViewer.getTable().setLayoutData(gd);
-		queriesViewer.setContentProvider(new NodeListContentProvider());
-		queriesViewer.getTable().setHeaderVisible(true);
-		queriesViewer.getTable().setLinesVisible(true);
-
-		String[] cols = {"name", "value", "desc"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-		for (String col : cols) {
-			TableViewerColumn columnViewer = new TableViewerColumn(queriesViewer, SWT.NONE);
-			TableColumn column = columnViewer.getColumn();
-			column.setText(col);
-			column.setWidth(100);
-			columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
-		}
+		/*
+		 * querySection = toolkit.createSection(form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		 * querySection.setText("Queries"); //$NON-NLS-1$
+		 * GridLayout layout = new GridLayout(1, true);
+		 * querySection.setLayout(layout);
+		 * querySection.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false, 2, 1));
+		 * querySection.setEnabled(false);
+		 * querySection.addExpansionListener(new ExpansionAdapter() {
+		 * @Override
+		 * public void expansionStateChanged(ExpansionEvent e) {form.layout(true);}
+		 * });
+		 * //filesection.setDescription("Select how to find source files");
+		 * Composite sectionClient = toolkit.createComposite(querySection);
+		 * sectionClient.setLayout(new GridLayout(2, false));
+		 * querySection.setClient(sectionClient);
+		 * Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_21, SWT.PUSH);
+		 * addButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		 * addButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
+		 * values.put("name", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("query", "[]"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("desc", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_21, values);
+		 * if (dlg.open() == Window.OK) {
+		 * params.addQuery(params.getCorpusElement(), values.get("name"), values.get("query"), values.get("desc")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * updateQuerySection();
+		 * }
+		 * }
+		 * });
+		 * Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_23, SWT.PUSH);
+		 * removeButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		 * removeButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * ISelection sel = queriesViewer.getSelection();
+		 * IStructuredSelection ssel = (IStructuredSelection) sel;
+		 * Object obj = ssel.getFirstElement();
+		 * if (obj instanceof Element) {
+		 * Element query = (Element) obj;
+		 * params.getQueriesElement(params.getCorpusElement()).removeChild(query);
+		 * updateQuerySection();
+		 * }
+		 * }
+		 * });
+		 * Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
+		 * queriesViewer = new TableViewer(table);
+		 * queriesViewer.getTable().addKeyListener(new TableKeyListener(queriesViewer));
+		 * GridData gd = new GridData(GridData.FILL, GridData.FILL, false, false,2,1);
+		 * gd.heightHint = 150;
+		 * queriesViewer.getTable().setLayoutData(gd);
+		 * queriesViewer.setContentProvider(new NodeListContentProvider());
+		 * queriesViewer.getTable().setHeaderVisible(true);
+		 * queriesViewer.getTable().setLinesVisible(true);
+		 * String[] cols = {"name", "value", "desc"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * for (String col : cols) {
+		 * TableViewerColumn columnViewer = new TableViewerColumn(queriesViewer, SWT.NONE);
+		 * TableColumn column = columnViewer.getColumn();
+		 * column.setText(col);
+		 * column.setWidth(100);
+		 * columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
+		 * }
 		 */
 	}
+	
 	private void createSAttributesSection() {
-		/*	sattrSection = toolkit.createSection(form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
-		sattrSection.setText(Messages.CorpusPage_24);
-		GridLayout layout = new GridLayout(1, true);
-		sattrSection.setLayout(layout);
-		sattrSection.setLayoutData(getSectionGridData(2));
-		sattrSection.setEnabled(false);
-
-		sattrSection.addExpansionListener(new ExpansionAdapter() {
-			@Override
-			public void expansionStateChanged(ExpansionEvent e) {form.layout(true);}
-		});
-
-		Composite sectionClient = toolkit.createComposite(sattrSection);
-		sectionClient.setLayout(new GridLayout(2, false));
-		sattrSection.setClient(sectionClient);
-
-		Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_25, SWT.PUSH);
-		addButton.setLayoutData(new GridData(GridData.BEGINNING, GridData.FILL, false, false));
-		addButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (params == null) return;
-				LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
-				values.put("id", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("shortname", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("longname", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("pattern", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("renderer", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("tooltip", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("type", "String"); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("import", "true"); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("mandatory", "true"); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("inputFormat", ""); //$NON-NLS-1$ //$NON-NLS-2$
-				values.put("outputFormat", ""); //$NON-NLS-1$ //$NON-NLS-2$
-
-				MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_25, values);
-				if (dlg.open() == Window.OK) {
-					params.addSAttribute(params.getCorpusElement(), values.get("id"), values.get("shortname"), values.get("longname"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-							values.get("type"), values.get("renderer"), values.get("tooltip"),  //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-							values.get("pattern"), values.get("import"), values.get("mandatory"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-							values.get("inputFormat"), values.get("outputFormat")); //$NON-NLS-1$ //$NON-NLS-2$
-					updateSAttributeSection();
-				}
-			}
-		});
-
-		Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_27, SWT.PUSH);
-		removeButton.setLayoutData(new GridData(GridData.BEGINNING, GridData.FILL, false, false));
-		removeButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if ( params == null) return;
-				ISelection sel = sattributesViewer.getSelection();
-				IStructuredSelection ssel = (IStructuredSelection) sel;
-				Object obj = ssel.getFirstElement();
-				if (obj instanceof Element) {
-					Element query = (Element) obj;
-					params.getSAttributesElement(params.getCorpusElement()).removeChild(query);
-					updateSAttributeSection();
-				}
-			}
-		});
-
-		Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
-		sattributesViewer = new TableViewer(table);
-		sattributesViewer.getTable().addKeyListener(new TableKeyListener(sattributesViewer));
-		GridData gdata = new GridData(GridData.FILL, GridData.FILL, false, false,2,1);
-		gdata.heightHint = 150;
-		sattributesViewer.getTable().setLayoutData(gdata);
-		sattributesViewer.setContentProvider(new NodeListContentProvider());
-		sattributesViewer.getTable().setHeaderVisible(true);
-		sattributesViewer.getTable().setLinesVisible(true);
-
-		String[] cols = {"id", "shortname", "longname", "import", "mandatory", "pattern", "renderer", "tooltip", "type"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$
-		for (String col : cols) {
-			TableViewerColumn columnViewer = new TableViewerColumn(sattributesViewer, SWT.NONE);
-			TableColumn column = columnViewer.getColumn();
-			column.setText(col);
-			//column.setWidth(10*col.length());
-			columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
-			column.pack();
-		}
+		/*
+		 * sattrSection = toolkit.createSection(form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE);
+		 * sattrSection.setText(Messages.CorpusPage_24);
+		 * GridLayout layout = new GridLayout(1, true);
+		 * sattrSection.setLayout(layout);
+		 * sattrSection.setLayoutData(getSectionGridData(2));
+		 * sattrSection.setEnabled(false);
+		 * sattrSection.addExpansionListener(new ExpansionAdapter() {
+		 * @Override
+		 * public void expansionStateChanged(ExpansionEvent e) {form.layout(true);}
+		 * });
+		 * Composite sectionClient = toolkit.createComposite(sattrSection);
+		 * sectionClient.setLayout(new GridLayout(2, false));
+		 * sattrSection.setClient(sectionClient);
+		 * Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_25, SWT.PUSH);
+		 * addButton.setLayoutData(new GridData(GridData.BEGINNING, GridData.FILL, false, false));
+		 * addButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
+		 * values.put("id", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("shortname", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("longname", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("pattern", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("renderer", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("tooltip", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("type", "String"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("import", "true"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("mandatory", "true"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("inputFormat", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("outputFormat", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_25, values);
+		 * if (dlg.open() == Window.OK) {
+		 * params.addSAttribute(params.getCorpusElement(), values.get("id"), values.get("shortname"), values.get("longname"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * values.get("type"), values.get("renderer"), values.get("tooltip"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * values.get("pattern"), values.get("import"), values.get("mandatory"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		 * values.get("inputFormat"), values.get("outputFormat")); //$NON-NLS-1$ //$NON-NLS-2$
+		 * updateSAttributeSection();
+		 * }
+		 * }
+		 * });
+		 * Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_27, SWT.PUSH);
+		 * removeButton.setLayoutData(new GridData(GridData.BEGINNING, GridData.FILL, false, false));
+		 * removeButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if ( params == null) return;
+		 * ISelection sel = sattributesViewer.getSelection();
+		 * IStructuredSelection ssel = (IStructuredSelection) sel;
+		 * Object obj = ssel.getFirstElement();
+		 * if (obj instanceof Element) {
+		 * Element query = (Element) obj;
+		 * params.getSAttributesElement(params.getCorpusElement()).removeChild(query);
+		 * updateSAttributeSection();
+		 * }
+		 * }
+		 * });
+		 * Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
+		 * sattributesViewer = new TableViewer(table);
+		 * sattributesViewer.getTable().addKeyListener(new TableKeyListener(sattributesViewer));
+		 * GridData gdata = new GridData(GridData.FILL, GridData.FILL, false, false,2,1);
+		 * gdata.heightHint = 150;
+		 * sattributesViewer.getTable().setLayoutData(gdata);
+		 * sattributesViewer.setContentProvider(new NodeListContentProvider());
+		 * sattributesViewer.getTable().setHeaderVisible(true);
+		 * sattributesViewer.getTable().setLinesVisible(true);
+		 * String[] cols = {"id", "shortname", "longname", "import", "mandatory", "pattern", "renderer", "tooltip", "type"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+		 * //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$
+		 * for (String col : cols) {
+		 * TableViewerColumn columnViewer = new TableViewerColumn(sattributesViewer, SWT.NONE);
+		 * TableColumn column = columnViewer.getColumn();
+		 * column.setText(col);
+		 * //column.setWidth(10*col.length());
+		 * columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
+		 * column.pack();
+		 * }
 		 */
 	}
-
+	
 	/**
 	 * Creates the tokenizer section.
 	 */
 	private int createTokenizerSection() {
-		tokenizerSection = new TokenizerSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR|ExpandableComposite.TWISTIE, moduleParams);
+		tokenizerSection = new TokenizerSection(toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE, moduleParams);
 		return tokenizerSection.getSectionSize();
 	}
-
+	
 	private void createToolbar() {
 		Composite hyperlinks = toolkit.createComposite(form.getBody());
 		TableWrapData gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL, 2, 1);
 		gdata.colspan = 2;
 		hyperlinks.setLayoutData(gdata);
-
+		
 		TableWrapLayout layout = new TableWrapLayout();
 		layout.numColumns = 4;
 		layout.makeColumnsEqualWidth = false;
 		hyperlinks.setLayout(layout);
-
-		Label titleLabel = toolkit.createLabel(hyperlinks,"", SWT.WRAP); //$NON-NLS-1$
+		
+		Label titleLabel = toolkit.createLabel(hyperlinks, "", SWT.WRAP); //$NON-NLS-1$
 		titleLabel.setLayoutData(new TableWrapData(TableWrapData.FILL, TableWrapData.TOP));
-		titleLabel.setText(NLS.bind(TXMUIMessages.importParametersOfP0, 
+		titleLabel.setText(NLS.bind(TXMUIMessages.importParametersOfP0,
 				ImportModuleCustomization.getName(editor.getGroovyScript().getName())));
 		FontData[] fD = titleLabel.getFont().getFontData();
 		fD[0].setHeight(16);
-		titleLabel.setFont( new Font(titleLabel.getDisplay(),fD[0]));
-
+		titleLabel.setFont(new Font(titleLabel.getDisplay(), fD[0]));
+		
 		HyperlinkAdapter selectDirHListener = new HyperlinkAdapter() {
+			
 			@Override
 			public void linkActivated(HyperlinkEvent e) {
-				//System.out.println("Opening...");
+				// System.out.println("Opening...");
 				selectSourceDir();
 			}
 		};
 		
 		HyperlinkAdapter saveHListener = new HyperlinkAdapter() {
+			
 			@Override
 			public void linkActivated(HyperlinkEvent e) {
 				if (project != null) {
 					saveConfig();
-				} else 
+				}
+				else
 					System.out.println(TXMUIMessages.cannotStartImportConfigurationNoSourceFolderSelected);
 			}
 		};
-
+		
 		HyperlinkAdapter startImportListener = new HyperlinkAdapter() {
+			
 			@Override
 			public void linkActivated(HyperlinkEvent e) {
-				//System.out.println("Starting...");
+				// System.out.println("Starting...");
 				if (project != null) {
 					if (saveConfig()) {
 						startImport();
 					}
-				} else 
+				}
+				else
 					System.out.println(TXMUIMessages.cannotStartImportConfigurationNoSourceFolderSelected);
 			}
 		};
-
+		
 		ImageHyperlink openImportLink = toolkit.createImageHyperlink(hyperlinks, SWT.NULL);
 		openImportLink.setLayoutData(new TableWrapData(TableWrapData.FILL, TableWrapData.MIDDLE));
 		openImportLink.setImage(IImageKeys.getImage(IImageKeys.FOLDER));
